<template>
  <section class="invoice-preview-wrapper">

    <!-- Alert: No item found -->
    <b-alert
      variant="danger"
      :show="invoiceData === undefined"
    >
      <h4 class="alert-heading">
        Error al obtener los datos de la factura
      </h4>
      <div class="alert-body">
        No se ha encontrado ninguna factura con este identificador de factura. Comprobar
        <b-link
          class="alert-link"
          :to="{ name: 'apps-invoice-list'}"
        >
          Lista de facturas
        </b-link>
        para otras facturas.
      </div>
    </b-alert>

    <b-row
      v-if="invoiceData"
      class="invoice-preview"
    >

      <!-- Col: Left (Invoice Container) -->
      <b-col
        cols="12"
        xl="9"
        md="8"
      >
        <b-card
          no-body
          class="invoice-preview-card"
        >
          <!-- Header -->
          <b-card-body class="invoice-padding pb-0">

            <div class="d-flex justify-content-between flex-md-row flex-column invoice-spacing mt-0">

              <!-- Header: Left Content -->
              <div>
                <div class="logo-wrapper">
                  <logo />
                  <!-- <h3 class="text-primary invoice-logo">
                    Qantumbit
                  </h3> -->
                </div>
                <p class="card-text mb-25">
                 Blvd. Luis Donaldo Colosio 294,
                </p>
                <p class="card-text mb-25">
                   Hermosillo, Sonora, MEX
                </p>
                <p class="card-text mb-0">
                  +52 662 341 4004
                </p>
              </div>

              <!-- Header: Right Content -->
              <div class="mt-md-0 mt-2">
                <h4 class="invoice-title">
                  Invoice
                  <span class="invoice-number">#{{ invoiceData.id }}</span>
                </h4>
                <div class="invoice-date-wrapper">
                  <p class="invoice-date-title">
                   Fecha de Emisión:
                  </p>
                  <p class="invoice-date">
                    {{ invoiceData.quoteDate }}
                  </p>
                </div>
                <div class="invoice-date-wrapper" v-show="invoiceData.validityDate">
                  <p class="invoice-date-title">
                   Fecha de validación:
                  </p>
                  <p class="invoice-date">
                    {{ invoiceData.validityDate }}
                  </p>
                </div>
              </div>
            </div>
          </b-card-body>

          <!-- Spacer -->
          <hr class="invoice-spacing">

          <!-- Invoice Client & Payment Details -->
          <b-card-body
            v-if="invoiceData.client"
            class="invoice-padding pt-0"
          >
            <b-row class="invoice-spacing">

              <!-- Col: Invoice To -->
              <b-col
                cols="12"
                xl="6"
                class="p-0"
              >
                <h6 class="mb-2">
                  Factura para:
                </h6>
                <h6 class="mb-25">
                  {{ invoiceData.client.name }}
                </h6>
                <p class="card-text mb-25">
                  {{ invoiceData.client.rfc }}
                </p>
              </b-col>

              <!-- Col: Payment Details -->
              <b-col
                xl="6"
                cols="12"
                class="p-0 mt-xl-0 mt-2 d-flex justify-content-xl-end"
              >
                <div>
                  <h6 class="mb-2">
                    Detalles de pago:
                  </h6>
                  <table>
                    <tbody>
                      <tr>
                        <td class="pr-1">
                          Total:
                        </td>
                        <td><span class="font-weight-bold">${{ invoiceData.total_amount }}</span></td>
                      </tr>
                      <tr v-show="invoiceData.discount">
                        <td class="pr-1">
                          Descuento:
                        </td>
                        <td>{{ invoiceData.discount }}%</td>
                      </tr>
                      <tr >
                        <td class="pr-1">
                          Moneda:
                        </td>
                        <td>{{ invoiceData.currencyType }}</td>
                      </tr>
                      <tr v-show="invoiceData.paymentType">
                        <td class="pr-1">
                          Método de pago:
                        </td>
                        <td>{{ invoiceData.paymentType }}</td>
                      </tr>
                      
                    </tbody>
                  </table>
                </div>
              </b-col>
            </b-row>
          </b-card-body>

          <b-card-body class="invoice-padding pt-0" v-show="invoiceData.paymentConditions">
            <span class="font-weight-bold">Condiciones de pago: </span>
            <span>{{ invoiceData.paymentConditions }}</span>
          </b-card-body>

          <!-- Invoice Description: Table -->
          <b-table-lite
            responsive
            :items="invoiceData.activities"
            :fields="['actividad', 'total']"
          >
            <template #cell(actividad)="data">
              <b-card-text class="font-weight-bold mb-25">
                {{ data.item.name }}
              </b-card-text>
            </template>
            <template #cell(total)="data">
              <b-card-text class="font-weight-bold mb-25">
                {{ data.item.pivot.total_cost }}
              </b-card-text>
            </template>
          </b-table-lite>

          

          <!-- Col: Total -->
          <b-card-body class="invoice-padding pb-0">

            <b-row v-show="invoiceData.currencyType==='MXN'">

                <!-- Col: Total MXN-->
                <b-col
                  cols="12"
                  md="10"
                  class="mt-md-6 d-flex justify-content-end"

                  
                >
                  <div class="invoice-total-wrapper" >
                    <div class="invoice-total-item">
                    </div>
                    <div class="invoice-total-item" >
                      <p class="invoice-total-title">
                        Subtotal:
                      </p>
                      <p class="invoice-total-amount">
                        <label>{{invoiceData.base_amount}}</label>
                        
                      </p>
                    </div>
                    <div class="invoice-total-item" v-show="invoiceData.discount">
                      <p class="invoice-total-title">
                        Descuento:
                      </p>
                      <p class="invoice-total-amount">
                        {{discountAmount}}
                      </p>
                    </div>
                    <div class="invoice-total-item" >
                      <p class="invoice-total-title">
                        IVA (16%):
                      </p>
                      <p class="invoice-total-amount">
                        {{invoiceData.taxes_amount}}
                      </p>
                    </div>
                    <hr class="my-50">
                    <div class="invoice-total-item">
                      <p class="invoice-total-title">
                        Total:
                      </p>
                      <p class="invoice-total-amount">
                        ${{invoiceData.total_amount}}
                      </p>
                    </div>
                  </div>
                </b-col>
            </b-row>
            <b-row v-show="invoiceData.currencyType==='USD'">

                <!-- Col: Total USD-->

                <b-col
                  cols="12"
                  md="6"
                  class="mt-md-6 d-flex justify-content-start"
                  order="3"
                  order-md="3"
                >
                  <div class="invoice-total-wrapper" >
                    <div class="invoice-total-item">
                      <p class="invoice-total-title">
                        Subtotal:
                      </p>
                      <p class="invoice-total-amount">
                        {{invoiceData.base_amount}}
                      </p>
                    </div>
                    <div class="invoice-total-item" v-show="invoiceData.discount">
                      <p class="invoice-total-title">
                        Descuento:
                      </p>
                      <p class="invoice-total-amount">
                        {{discountAmount}}
                      </p>
                    </div>
                    <div class="invoice-total-item">
                      <p class="invoice-total-title">
                        Impuesto (5.6%):
                      </p>
                      <p class="invoice-total-amount">
                        {{invoiceData.taxes_amount}}
                      </p>
                    </div>
                    <hr class="my-50">
                    <div class="invoice-total-item">
                      <p class="invoice-total-title">
                        Total (USD):
                      </p>
                      <p class="invoice-total-amount">
                        ${{invoiceData.total_amount}}
                      </p>
                    </div>
                  </div>
                </b-col>

                <!-- Col: Total MXN-->
                <b-col
                  cols="12"
                  md="6"
                  class="mt-md-6 d-flex justify-content-start"
                  order="2"
                  order-md="2"
                >
                  <div class="invoice-total-wrapper" >
                    <div class="invoice-total-item">
                    </div>
                    <div class="invoice-total-item">
                      <p class="invoice-total-title">
                        Subtotal:
                      </p>
                      <p class="invoice-total-amount">
                        <label>{{baseAmount}}</label>
                        
                      </p>
                    </div>
                    <div class="invoice-total-item" v-show="invoiceData.discount">
                      <p class="invoice-total-title">
                        Descuento:
                      </p>
                      <p class="invoice-total-amount">
                        {{discountConvertion}}
                      </p>
                    </div>
                    <div class="invoice-total-item" >
                      <p class="invoice-total-title">
                        Impuesto (5.6%):
                      </p>
                      <p class="invoice-total-amount">
                        {{taxesAmount}}
                      </p>
                    </div>
                    <hr class="my-50">
                    <div class="invoice-total-item">
                      <p class="invoice-total-title">
                        Total equvalente (MXN):
                      </p>
                      <p class="invoice-total-amount">
                        ${{totalAmount}}
                      </p>
                    </div>
                  </div>
                </b-col>

            </b-row>

          </b-card-body>

          <!-- Spacer -->
          <hr class="invoice-spacing">

          <!-- Note -->
          <!-- <b-card-body class="invoice-padding pt-0">
            <span class="font-weight-bold">Note: </span>
            <span>!</span>
          </b-card-body> -->
        </b-card>
      </b-col>

      <!-- Right Col: Card -->
      <b-col
        cols="12"
        md="4"
        xl="3"
        class="invoice-actions"
      >
        <b-card>

          <b-button
              v-ripple.400="'rgba(255, 255, 255, 0.15)'"
              variant="success"
              class="mb-75"
              block
              v-show="invoiceData.status===1 && checkValidatePermission()"
              @click="validar()"
            >
              Validar
          </b-button>
          <!-- Button: Add Payment -->
          <b-button
              v-ripple.400="'rgba(255, 255, 255, 0.15)'"
              variant="success"
              class="mb-75"
              block
              v-show="invoiceData.status===7"
              @click="pagada()"
            >
              Pagada
          </b-button>

          <!-- Button: Send Invoice -->
          <b-button
            v-ripple.400="'rgba(255, 255, 255, 0.15)'"
            v-b-toggle.sidebar-send-invoice
    
            variant="primary"
            class="mb-75"
            block
            @click="showModal"
            v-show="(invoiceData.status===6 || invoiceData.status===7) && checkValidatePermission()"
          >
            Enviar
          </b-button>

          <!-- Button: DOwnload -->
          <b-button
            v-ripple.400="'rgba(186, 191, 199, 0.15)'"
            variant="outline-secondary"
            class="mb-75"
            block
            @click="downloadInvoice"
            v-show="invoiceData.status===6 || invoiceData.status===7"
          >
            Descargar
          </b-button>


          <!-- Button: Edit -->
          <b-button
            v-ripple.400="'rgba(186, 191, 199, 0.15)'"
            variant="outline-secondary"
            class="mb-75"
            block
            v-show="invoiceData.status===1"
            :to="{ name: 'apps-invoice-edit', params: { id: $route.params.id } }"
          >
            Editar
          </b-button>

          <!-- Button: Cancel -->
          <b-button
            v-ripple.400="'rgba(186, 191, 199, 0.15)'"
            variant="outline-secondary"
            class="mb-75"
            block
            v-show="invoiceData.status===1 ||invoiceData.status===7 ||invoiceData.status===7"
            @click="cancelInvoice"
          >
            Cancelar
          </b-button>

          <modal-send-invoice :id="invoiceData.id"></modal-send-invoice>

        </b-card>
      </b-col>
    </b-row>

  </section>
</template>

<script>
import {
  BRow, BCol, BCard, BCardBody, BTableLite, BCardText, BButton, BAlert, BLink, VBToggle,
} from 'bootstrap-vue'
import Logo from '@core/layouts/components/Logo.vue'
import Ripple from 'vue-ripple-directive'
import ModalSendInvoice from './ModalSendInvoice.vue'

export default {
  directives: {
    Ripple,
    'b-toggle': VBToggle,
  },
  components: {
    ModalSendInvoice,
    BRow,
    BCol,
    BCard,
    BCardBody,
    BTableLite,
    BCardText,
    BButton,
    BAlert,
    BLink,

    Logo,
  },
  data() {
    return {
      total_amount:0,
      base_amount:0,
      taxes_amount:0,
      discount_amount:0,
      discount_convertion:0,
      invoiceData:{
        id:0,
        quoteDate:'',
        validityDate:'',
        project:'',
        discount:0,
        paymentType:'',
        paymentConditions:'',
        currencyType:'',
        conversion_rate:'',
        base_amount:0,
        total_amount:0,
        taxes_amount:0,
        activities: [],
        client:''
      },
    }
  },
  methods:{
    getInvoice(){
      this.$http.get("invoice/show", {params:{id:this.$route.params.id}}).then((res) => {
        this.invoiceData.id=res.data.invoice.id
        this.invoiceData.quoteDate=res.data.invoice.quote_date
        this.invoiceData.validityDate=res.data.invoice.validity_date
        this.invoiceData.project=res.data.invoice.project
        this.invoiceData.discount=res.data.invoice.discount
        this.invoiceData.paymentType=res.data.invoice.payment_type
        this.invoiceData.paymentConditions=res.data.invoice.payment_conditions
        this.invoiceData.currencyType=res.data.invoice.currency_type
        this.invoiceData.conversion_rate=res.data.invoice.conversion_rate
        this.invoiceData.base_amount=res.data.invoice.base_amount
        this.invoiceData.taxes_amount=res.data.invoice.taxes_amount
        this.invoiceData.total_amount=res.data.invoice.total_amount
        this.invoiceData.activities=res.data.invoice.activities
        this.invoiceData.client=res.data.invoice.client
        this.invoiceData.status=res.data.invoice.status_id
      }).catch(err=>{
        console.log(err);
      })

    },
    validar(){
      this.$swal({
        title: '¿Está seguro de validar la factura?',
        text: "No podrás hacer cambios!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, validar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          this.$http.post("invoice/changeStatus", {id:this.$route.params.id}).then((res) => {
            if(res.data.message === 'modificado'){
              this.$swal({
                icon: 'success',
                title: 'Validado!',
                text: 'La factura se a validado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
              this.$router.push({ name: "apps-invoice-list" });
            }else{
              this.$swal({
                title: 'Error!',
                text: ' No se pudo validar!',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }
            
          }).catch(err=>{
            console.log(err);
          })

          
        } else if (result.dismiss === 'cancel') {
          this.$swal({
            title: 'Cancelado',
            text: '',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
      })
      
    },
    pagada(){
      this.$swal({
        title: '¿Está seguro de que la factura esta pagada?',
        text: "No podrás hacer cambios!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, pagada!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          this.$http.post("invoice/changeStatusPaid", {id:this.$route.params.id}).then((res) => {
            if(res.data.message === 'modificado'){
              this.$swal({
                icon: 'success',
                title: 'Pagado!',
                text: 'La factura se a pagado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
              this.$router.push({ name: "apps-invoice-list" });
            }else{
              this.$swal({
                title: 'Error!',
                text: ' No se pudo cambiar el status!',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }
            
          }).catch(err=>{
            console.log(err);
          })

          
        } else if (result.dismiss === 'cancel') {
          this.$swal({
            title: 'Cancelado',
            text: '',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
      })
      
    },
    downloadInvoice(){
      this.$http.get("invoice/pdf", {params:{id:this.invoiceData.id}, responseType: 'blob'}).then((res) => {
        let fileURL = window.URL.createObjectURL(new Blob([res.data]));
        let fileLink = document.createElement('a');
        fileLink.href = fileURL;
        fileLink.setAttribute('download', 'Factura '+this.invoiceData.id+'.pdf');
        document.body.appendChild(fileLink);
        fileLink.click();
        
      }).catch(err=>{
        console.log(err);
      })
    },
    cancelInvoice() {
      this.$swal({
        title: '¿Está seguro de cancelar la factura?',
        text: "No podrás hacer cambios!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, cancelar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          this.$http.post("invoice/cancel", {id:this.$route.params.id}).then((res) => {
            if(res.data.message === 'modificado'){
              this.$swal({
                icon: 'success',
                title: 'Cancelada!',
                text: 'La factura a sido cancelada.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
              this.$router.push({ name: "apps-invoice-list" });
            }else{
              this.$swal({
                title: 'Error!',
                text: ' No se pudo cancelar!',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }
            
          }).catch(err=>{
            console.log(err);
          })
        } else if (result.dismiss === 'cancel') {
          this.$swal({
            title: 'Cancelado',
            text: '',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
      })
    },
    showModal(){
      this.$bvModal.show('modal-email')
    },
    checkValidatePermission(){
      let userData = JSON.parse(localStorage.userData)
  
      if((userData.permissions.find( permission => permission.name === 'send_invoices' ))){
          return true
      }else {
          return false
        }
    }
  },
  computed:{
    baseAmount(){
      return this.base_amount=Number.parseFloat(this.invoiceData.base_amount * this.invoiceData.conversion_rate).toFixed(2);
    },
    discountAmount(){
      return this.discount_amount=Number.parseFloat((this.invoiceData.discount / 100) * this.invoiceData.base_amount).toFixed(2);
    },
    discountConvertion(){
      return this.discount_convertion=Number.parseFloat(this.discount_amount * Number.parseFloat(this.invoiceData.conversion_rate).toFixed(2)).toFixed(2);
    },
    taxesAmount(){
      return this.taxes_amount=Number.parseFloat(this.invoiceData.taxes_amount * Number.parseFloat(this.invoiceData.conversion_rate).toFixed(2)).toFixed(2);
    },
    totalAmount(){
      return this.total_amount=Number.parseFloat(this.invoiceData.total_amount * this.invoiceData.conversion_rate).toFixed(2);
    }
  },
  mounted(){
    this.getInvoice()    
  }
}
</script>

<style lang="scss" scoped>
@import "~@core/scss/base/pages/app-invoice.scss";
</style>

<style lang="scss">
@media print {

  // Global Styles
  body {
    background-color: transparent !important;
  }
  nav.header-navbar {
    display: none;
  }
  .main-menu {
    display: none;
  }
  .header-navbar-shadow {
    display: none !important;
  }
  .content.app-content {
    margin-left: 0;
    padding-top: 2rem !important;
  }
  footer.footer {
    display: none;
  }
  .card {
    background-color: transparent;
    box-shadow: none;
  }
  .customizer-toggle {
    display: none !important;
  }

  // Invoice Specific Styles
  .invoice-preview-wrapper {
    .row.invoice-preview {
      .col-md-8 {
        max-width: 100%;
        flex-grow: 1;
      }

      .invoice-preview-card {
        .card-body:nth-of-type(2) {
          .row {
              > .col-12 {
              max-width: 50% !important;
            }

            .col-12:nth-child(2) {
              display: flex;
              align-items: flex-start;
              justify-content: flex-end;
              margin-top: 0 !important;
            }
          }
        }
      }
    }

    // Action Right Col
    .invoice-actions {
      display: none;
    }
  }
}
</style>
